'''Game main module.

Contains the entry point used by the run_game.py script.
'''

import atexit

from phoenix.game import PhoenixGame
from phoenix.display import PhoenixUI
from phoenix.save import PhoenixSave

from ui.cursesemu import StdScr

def main(datadir):
    StdScr.DATADIR = datadir
    
    save = PhoenixSave()
    game = PhoenixGame()
    
    if save.is_available():
        game.set_highscores(save.load())
    
    atexit.register(lambda: save.save(game.highscores()))
    
    ui = PhoenixUI(game)
    
    ui.main()
