'''Cute and cuddly monsters in Phoenix.'''

import random

from concepts.units import *



class Monster:
    def __init__(self, strength, agility, greed, gold, name, gender = None):
        if gender is None:
            gender = RANDOM_GENDER
        
        self._strength = strength
        self._agility  = agility
        self._greed    = greed
        self._name     = name
        self._gold     = gold
        self._gender   = gender()
        
    def name(self):
        return self._name
    
    def agility(self):
        return self._agility
    
    def strength(self):
        return self._strength
    
    def greed(self):
        return self._greed
    
    def gold(self):
        return self._gold
    
    def gender(self):
        return self._gender
        
    def __str__(self):
        return self._name
    
    


def GOBLIN():
    return Monster( 10, 20,  50,  10, 'Goblin')

def BANDIT(): 
    return Monster( 20, 50, 250, 100, 'Bandit')

def ELF():
    return Monster( 30, 90,  50,  50, 'Elf')

def MERMAID():
    return Monster( 35, 30, 100,   0, 'Mermaid', FEMALE)

def MERMAN():
    return Monster( 35, 30, 100,   0, 'Merman', MALE)

def DRYAD():
    return Monster( 40, 95, 200,   0, 'Dryad', FEMALE)

def ORC():
    return Monster( 50, 75, 150,  40, 'Orc')

def ROBBER():
    return Monster( 55, 50, 500, 500, 'Robber')

def TROLL():
    return Monster( 60, 30, 150,  50, 'Troll')

def DRUID():
    return Monster( 70, 20, 200, 200, 'Druid')

def TREANT():
    return Monster( 80, 10, 100,  50, 'Treant')

def HILL_ORC():
    return Monster( 90, 20, 200,  250, 'Hill Orc')

def OGRE():
    return Monster(100, 50,  50, 150, 'Ogre')

def MOUNTAIN_TROLL():
    return Monster(110, 40,  50, 150, 'Mountain Troll')

def YETI():
    return Monster(120, 70,   0, 200, 'Yeti')
