'''Phoenix savegames.'''

import os
import pickle



class PhoenixSave:
    def __init__(self):
        self.data_py = os.path.abspath(os.path.dirname(__file__))
        self.data_dir = os.path.normpath(os.path.join(self.data_py, '..', '..', 'data'))
        self.file = 'state.p'
        
    def _filepath(self, filename):
        return os.path.join(self.data_dir, filename)

    def _open(self, filename, mode):
        return open(os.path.join(self.data_dir, filename), mode)
    
    def load(self):
        return pickle.load(self._open(self.file, 'r'))
    
    def save(self, game):
        return pickle.dump(game, self._open(self.file, 'w'))
    
    def is_available(self):
        return os.access(self._filepath(self.file), os.F_OK)
    